#line 1 "C:/Evil Genius/MikroProC/P18F45K22/WS2811 with LCD/WS2811.c"
#line 1 "c:/evil genius/mikroproc/p18f45k22/ws2811 with lcd/ws2811.h"
#line 44 "c:/evil genius/mikroproc/p18f45k22/ws2811 with lcd/ws2811.h"
char MAX_LED_COUNT;
signed long led_strip_colors[256];
int i, j;
char txt[7];
char row, col, Disp_Enable;
char AtoD_Ch;
unsigned char last_event;
signed int v;
unsigned char brightness = 1;
unsigned int speede;

void WS2811_AtoD_Display(char row_temp, char col_temp, int val, char disp_ena)
{
 AtoD_Ch = val;
 Disp_Enable = disp_ena;
 if(Disp_Enable == 0)
 {
 speede = 10;
 }
 row = row_temp;
 col = col_temp;
 return;
}

void WS2811_frame()
{
 unsigned int i;
 unsigned long this_led;
 unsigned int loop;

 if(Disp_Enable == 1)
 {
 speede = ADC_Read(AtoD_Ch);
 InttoStr(speede, txt);
 LCD_Out(row, col, txt);
 LCD_Out(row, col + 6, " ms");
 }

 for(i = 0; i < MAX_LED_COUNT; i++)
 {
 this_led = led_strip_colors[i];
 for(loop = 0; loop < 24; loop++)
 {
 if( ((this_led) & (1 <<(23))) )
 {
 spi1_write( 0b11110000 );
 }
 else
 {
 spi1_write( 0b10000000 );
 }
 this_led *= 2;
 }
 }
 delay_us(75);
 vdelay_ms(speede);
}

void WS2811_fixed(int frame_speed)
{
 unsigned int i;
 unsigned long this_led;
 unsigned int loop;

 for(i = 0; i < MAX_LED_COUNT; i++)
 {
 this_led = led_strip_colors[i];
 for(loop = 0; loop < 24; loop++)
 {
 if( ((this_led) & (1 <<(23))) )
 {
 spi1_write( 0b11110000 );
 }
 else
 {
 spi1_write( 0b10000000 );
 }
 this_led *= 2;
 }
 }
 delay_us(75);
 vdelay_ms(frame_speed);
}


void WS2811_LEDCount(char vari)
{
 MAX_LED_COUNT = vari + 6;
 return;
}

void Clear_Strip()
{
char pos;

 for(pos = 0; pos < MAX_LED_COUNT; pos++)
 {
 led_strip_colors[pos] = 0x000000;
 }
 WS2811_frame();
}



unsigned long Strip_Color(char g, char r, char b)
 {
 return ((unsigned long)g << 16) | ((unsigned long)r << 8) | b;
 }

Set_Color(unsigned long rred, unsigned int ggreen, char bblue,
 char position)
{
 unsigned long temp, temp1;

 temp = 0;
 temp1 = 0;
 temp1 = (rred / brightness) << 16;
 temp = temp + temp1;
 temp1 = 0;
 temp1 = (ggreen / brightness) << 8;
 temp = temp + temp1;
 temp1 = 0;
 temp1 = (bblue / brightness);
 temp = temp + temp1;
 led_strip_colors[position] = temp;
}



unsigned long Wheel(char WheelPos)
{
 if(WheelPos < 85)
 {
 return Strip_Color(WheelPos * 3, 255 - WheelPos * 3, 0);
 }
 else if(WheelPos < 170)
 {
 WheelPos -= 85;
 return Strip_Color(255 - WheelPos * 3, 0, WheelPos * 3);
 }
 else
 {
 WheelPos -= 170;
 return Strip_Color(0, WheelPos * 3, 255 - WheelPos * 3);
 }
}

void RandomColor(int loops, int frame_speed)
{
unsigned char a, b, c, d;

for (j = 0; j < loops; j++)
 {
 srand(j);
 a = rand() % 255;
 b = rand() % 255;
 c = rand() % 255;
 d = rand() % MAX_LED_COUNT;

 Set_Color(a, b, c, d);
 WS2811_fixed(frame_speed);
 }
}

void ChaseRandom(int loops)
{
 unsigned int x;
 unsigned long new_color = 0;
for (j = 0; j < loops; j++)
 {

 for(x = (MAX_LED_COUNT - 1); x > 0; x--)
 {
 led_strip_colors[x] = led_strip_colors[x - 1];
 }

 for(x = 0; x < 3; x++)
 {
 new_color <<= 8;
 new_color |= rand();
 }
 led_strip_colors[0] = new_color;
 WS2811_frame();
 }
}

void Fade_Strip(char rrednext, char ggreennext, char bbluenext,
 char rredlast, char ggreenlast, char bbluelast,
 int pos)
{

 float rlast, glast, blast, rcurr, gcurr, bcurr, rcalc, gcalc, bcalc;
 float MaxTemp, MaxStep, rtemp, gtemp, btemp;
 unsigned long temp, temp1;
 unsigned char goFlag, nnn, count;
 unsigned long rred;
 unsigned int ggreen;
 unsigned char bblue;

 count = 0;
 goFlag = 1;
 while(goFlag == 1)
 {
 rcurr = rredlast;
 gcurr = ggreenlast;
 bcurr = bbluelast;
 rlast = rrednext;
 glast = ggreennext;
 blast = bbluenext;
 MaxTemp = max((abs(rcurr - rlast)), (abs(gcurr - glast)));
 MaxStep = max((abs(bcurr - blast)), MaxTemp);
 rcalc = rlast;
 gcalc = glast;
 bcalc = blast;


 for (nnn = 0; nnn < MaxStep; nnn++)
 {
 rtemp = (rcurr - rlast) / MaxStep;
 gtemp = (gcurr - glast) / MaxStep;
 btemp = (bcurr - blast) / MaxStep;
 rcalc = rcalc + rtemp;
 gcalc = gcalc + gtemp;
 bcalc = bcalc + btemp;
 rred = rcalc;
 ggreen = gcalc;
 bblue = bcalc;


 temp = 0;
 temp1 = 0;
 temp1 = rred << 16;
 temp = temp + temp1;
 temp1 = 0;
 temp1 = ggreen << 8;
 temp = temp + temp1;
 temp1 = 0;
 temp1 = bblue;
 temp = temp + temp1;



 if(pos == 0)
 {
 for (count = 0; count < MAX_LED_COUNT + 1; ++count)
 {
 led_strip_colors[count] = temp;
 }
 }
 else
 {
 led_strip_colors[pos] = temp;
 }
 if(last_event == 1)
 {
 last_event = 0;
 return;
 }


 WS2811_frame();
 }
 goFlag = 0;
 }
}

void Solid_Strip(char r1, char g1, char b1)
{
char pos;

 for(pos = 0; pos < MAX_LED_COUNT; pos++)
 {
 if(last_event == 1)
 {
 last_event = 0;
 return;
 }
 Set_Color(r1, g1, b1, pos);
 }
 WS2811_frame();
}

void InsertColor(char r1, char g1, char b1)
{
 unsigned int x;
 unsigned long new_color = 0;

 for(x = (MAX_LED_COUNT - 1); x > 0; x--)
 {
 led_strip_colors[x] = led_strip_colors[x - 1];
 }
 Set_Color(r1, g1, b1, 0);
 if(last_event == 1)
 {
 last_event = 0;
 return;
 }
 WS2811_frame();

}

void FillLeft(char r1, char g1, char b1)
{
 unsigned char count;
 for(count = MAX_LED_COUNT; count > 0; count--)
 {
 if(last_event == 1)
 {
 last_event = 0;
 return;
 }
 Set_Color(r1, g1, b1, count - 1);
 WS2811_frame();
 }
}

void FillRight(char r1, char g1, char b1)
{
 char count;
 for(count = 0; count < MAX_LED_COUNT; count++)
 {
 if(last_event == 1)
 {
 last_event = 0;
 return;
 }
 Set_Color(r1, g1, b1, count);
 WS2811_frame();
 }
}


void Fill_Any_PosR
(char r1, char g1, char b1, char r2, char g2, char b2,
 char r3, char g3, char b3, char start, char end)
{
char pos;
 for(pos = start; pos < end; pos++)
 {
 if(last_event == 1)
 {
 last_event = 0;
 return;
 }
 if((pos%3) == 0) {Set_Color(r3, g3, b3, pos);}
 if((pos%3) == 1) {Set_Color(r2, g2, b2, pos);}
 if((pos%3) == 2) {Set_Color(r1, g1, b1, pos);}

 WS2811_frame();
 }
}


void Fill_Any_PosL(char r1, char g1, char b1, char r2, char g2, char b2,
 char r3, char g3, char b3, char start, char end)
{
char pos;
 for(pos = start; pos > end; pos--)
 {
 if(last_event == 1)
 {
 last_event = 0;
 return;
 }
 if((pos%3) == 0) {Set_Color(r1, g1, b1, pos - 1);}
 if((pos%3) == 1) {Set_Color(r2, g2, b2, pos - 1);}
 if((pos%3) == 2) {Set_Color(r3, g3, b3, pos - 1);}

 WS2811_frame();
 }
}

void Chase_3Color_Left(char r1, char g1, char b1, char r2, char g2, char b2,
 char r3, char g3, char b3, int repeat)
{
char i, strt, pos, loopframe;

 pos = MAX_LED_COUNT;
 for(loopframe = 0; loopframe < repeat; loopframe++)
 {

 Set_Color(r3, g3, b3, pos + 2);
 Set_Color(r2, g2, b2, pos + 1);
 Set_Color(r1, g1, b1, pos);
 pos--;
 if (pos == MAX_LED_COUNT - 3)
 {
 pos = MAX_LED_COUNT;
 }

 for(strt = 0; strt < MAX_LED_COUNT; strt++)
 {
 led_strip_colors[strt] = led_strip_colors[strt + 1];
 }
 WS2811_frame();
 }

}

void Chase_3Color_Right(char r1, char g1, char b1, char r2, char g2, char b2,
 char r3, char g3, char b3, int repeat)
{
char i, loopframe;
char pos;
signed int strt;

 pos = 0;

 for(loopframe = 0; loopframe < repeat; loopframe++)
 {
 if(last_event == 1)
 {
 last_event = 0;
 return;
 }

 Set_Color(r1, g1, b1, pos - 0);
 Set_Color(r2, g2, b2, pos - 1);
 Set_Color(r3, g3, b3, pos - 2);
 pos++;
 if(pos == 3)
 {
 pos = 0;
 }

 for(strt = MAX_LED_COUNT; strt >= 0; strt--)
 {
 led_strip_colors[strt + 1] = led_strip_colors[strt];
 }
 WS2811_frame();
 }

}

void MovLeft_Chase_and_Clear(char position)
{
char pos, loopframe;
 for(loopframe = 0; loopframe < position; loopframe++)
 {
 if(last_event == 1)
 {
 last_event = 0;
 return;
 }
 for(pos = 0; pos < MAX_LED_COUNT; pos++)
 {
 led_strip_colors[pos] = led_strip_colors[pos + 1];
 }
 WS2811_frame();
 led_strip_colors[MAX_LED_COUNT] = 0x000000;
 }
}

void MovRight_Chase_and_Clear(char position)
{
char pos, loopframe;
 for(loopframe = 0; loopframe < position; loopframe++)
 {
 if(last_event == 1)
 {
 last_event = 0;
 return;
 }
 for(pos = (MAX_LED_COUNT - 1); pos > 0; pos--)
 {
 led_strip_colors[pos] = led_strip_colors[pos - 1];
 }
 WS2811_frame();
 led_strip_colors[0] = 0x000000;
 }
}

void Fill_Dot (char r1, char g1, char b1, char pos)
{
 Set_Color(r1, g1, b1, pos);
 WS2811_frame();

}

void Fill_Dot_PosR (char r1, char g1, char b1, char start, char end)
{
unsigned char pos;
 for(pos = start; pos <= end; pos++)
 {
 Set_Color(r1, g1, b1, pos);
 }
 WS2811_frame();

}

void Fill_Dot_PosL(char r1, char g1, char b1, char start, char end)
{
char pos;
 for(pos = start; pos >= end; pos--)
 {
 Set_Color(r1, g1, b1, pos - 1);
 }
 WS2811_frame();

}


void rainbowCycleLeft(unsigned char cycles, int frame_speed)
{
 for(j = 0; j < 256 * cycles; j++)
 {
 for(i = 0; i < MAX_LED_COUNT; i++)
 {
 led_strip_colors[i] = Wheel(((i * 256 / MAX_LED_COUNT) + j) & 255);
 }
 WS2811_frame();

 }
}


void rainbowCycleRight(unsigned char cycles, int frame_speed)
{
 for(j = 256 * cycles; j--;)
 {
 for(i = 0; i < MAX_LED_COUNT; i++)
 {
 led_strip_colors[i] = Wheel(((i * 256 / MAX_LED_COUNT) + j) & 255);
 }
 WS2811_frame();

 }
}

void CometLeft(unsigned char rred, unsigned char ggreen, unsigned char bblue)
{

 for(v = 0; v < MAX_LED_COUNT +  10  - 1; v++)
 {
 Set_Color(rred, ggreen, bblue, v);
 Set_Color(rred / 2, ggreen / 2, bblue / 2, v - 1);
 Set_Color(rred / 4, ggreen / 4, bblue / 4, v - 2);
 Set_Color(rred / 8, ggreen / 8, bblue / 8, v - 3);
 Set_Color(rred / 16, ggreen / 16, bblue / 16, v - 4);
 Set_Color(rred / 32, ggreen / 32, bblue / 32, v - 5);
 Set_Color(rred / 64, ggreen / 64, bblue / 64, v - 6);
 Set_Color(rred / 128, ggreen / 128, bblue / 128, v - 7);
 Set_Color(0, 0, 0, v - 8);
 WS2811_frame();
 }
 return;
}

void CometRight(unsigned char rred, unsigned char ggreen, unsigned char bblue)
{
 for(v = MAX_LED_COUNT; v--;)
 {
 Set_Color(rred, ggreen, bblue, v - 9);
 Set_Color(rred / 2, ggreen / 2, bblue / 2, v - 8);
 Set_Color(rred / 4, ggreen / 4, bblue / 4, v - 7);
 Set_Color(rred / 8, ggreen / 8, bblue / 8, v - 6);
 Set_Color(rred / 16, ggreen / 16, bblue / 16, v - 5);
 Set_Color(rred / 32, ggreen / 32, bblue / 32, v - 4);
 Set_Color(rred / 64, ggreen / 64, bblue / 64, v - 3);
 Set_Color(rred / 128, ggreen / 128, bblue / 128, v - 2 );
 Set_Color(0, 0, 0, v - 1);
 WS2811_frame();
 }
}
#line 1 "c:/evil genius/mikroproc/p18f45k22/ws2811 with lcd/delay_sub.h"




void delay(unsigned int timer)
{
vdelay_ms(timer);
}
#line 24 "C:/Evil Genius/MikroProC/P18F45K22/WS2811 with LCD/WS2811.c"
sbit LCD_RS at LATB4_bit;
sbit LCD_EN at LATB5_bit;
sbit LCD_D4 at LATB0_bit;
sbit LCD_D5 at LATB1_bit;
sbit LCD_D6 at LATB2_bit;
sbit LCD_D7 at LATB3_bit;

sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;





char Message1[17] = "WS2811 Demo     ";
char Message2[17] = "P18F45K22  V1.0 ";
char Message3[17] = "Chase Right     ";
char Message4[17] = "Chase Left      ";
char Message5[17] = "Fill Right      ";
char Message6[17] = "Fill Left       ";
char Message7[17] = "Fill Right Clear";
char Message8[17] = "Fill Left Clear ";
char Message9[17] = "Fill Strip      ";
char Message10[17] = "Insert Color    ";
char Message11[17] = "Move Left Clear ";
char Message12[17] = "Move Right Clear";
char Message13[17] = "Fill Short Left ";
char Message14[17] = "Fill Short Right";
char Message15[17] = "Fade Strip      ";
char Message16[17] = "Rainbow Right   ";
char Message17[17] = "Rainbow Left    ";
char Message18[17] = "Comet Left      ";
char Message19[17] = "Comet Right     ";
char Message20[17] = "Fill Dot Pos R  ";
char Message21[17] = "Fill Dot Pos L  ";
char Message22[17] = "Fill Dots       ";
char Message23[17] = "Chase 3 Color R ";
char Message24[17] = "Chase 3 Color L ";
char Message25[17] = "Fill Any Pos R  ";
char Message26[17] = "Fill Any Pos L  ";
char Message27[17] = "Solid Strip     ";
char Message28[17] = "Chase Random    ";
char Message29[17] = "Random Color    ";
char Message90[17] = "Delay";
char Message99[17] = "                ";
char pos, noc, strt, repeat;
char m, b, o;
unsigned char old[5], new[5], count[5];
unsigned char step, counter;
unsigned int disp_spd;



void main(void)
{

 ANSELA = 0b00000001;
 ANSELB = 0b00000000;
 ANSELC = 0b00000000;
 ANSELD = 0b00000000;
 ANSELE = 0b00000000;
 PORTA = 0b00000000;
 PORTB = 0b00000000;
 PORTC = 0b00000000;
 PORTD = 0b00000000;
 TRISA = 0b00000001;
 TRISB = 0b00000000;
 TRISC = 0b00000000;
 TRISD = 0b00000000;
 TRISE = 0b00000000;



 LCD_Init();
 Delay(100);
 ADC_Init();
 LCD_Out(1, 1, Message1);
 LCD_Out(2, 1, Message2);
 Delay(4000);
 LCD_Out(1, 1, Message99);
 LCD_Out(1, 1, Message90);
 LCD_Out(2, 1, Message99);
 LCD_Cmd(_LCD_CURSOR_OFF);

 SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV16, _SPI_DATA_SAMPLE_MIDDLE,
 _SPI_CLK_IDLE_LOW, _SPI_LOW_2_HIGH);
 delay(250);
 speede = 0;
 WS2811_LEDCount(55);
 WS2811_AtoD_Display(1, 6, 0, 1);
 Solid_Strip( 0,0,0 );

while(1 == 1)
{

 LCD_Out(2, 1, Message19);
 delay(1000);
 CometRight( 0,255,0 );

 LCD_Out(2, 1, Message18);
 delay(1000);
 CometLeft( 255,0,0 );

 LCD_Out(2, 1, Message19);
 delay(1000);
 CometRight( 0,0,255 );

 LCD_Out(2, 1, Message16);
 delay(1000);
 rainbowCycleRight(1, 5);

 LCD_Out(2, 1, Message29);
 delay(1000);
 RandomColor(1000, 5);

 LCD_Out(2, 1, Message16);
 delay(1000);
 rainbowCycleRight(1, 5);

for(counter = 0; counter < 2; ++counter)
 {
 InsertColor( 0,0,0  );
 InsertColor( 245,40,100 );
 InsertColor( 0,255,255  );
 InsertColor( 255,255,0 );
 InsertColor( 30,255,12  );
 InsertColor( 0,255,0 );
 InsertColor( 255,255,255  );
 InsertColor( 3,220,3 );
 InsertColor( 255,0,0  );
 InsertColor( 20,255,0 );
 InsertColor( 0,0,255  );
 InsertColor( 220,100,47 );
 InsertColor( 0,75,130  );
 InsertColor( 254,64,20 );
 InsertColor( 206,135,255  );
 InsertColor( 160,255,0 );
 }

 LCD_Out(2, 1, Message22);
 delay(2000);
 Fill_Dot_PosR( 0,255,0 , 0, 15);
 delay(100);
 Fill_Dot_PosR( 255,0,0 , 20, 35);
 delay(100);
 Fill_Dot_PosR( 0,0,255 , 40, 55);
 delay(2000);

 LCD_Out(2, 1, Message27);
 delay(2000);
 Solid_Strip( 0,0,0 );
 delay(2000);
 Solid_Strip( 160,255,0 );
 delay(2000);
 Solid_Strip( 30,255,12 );
 delay(2000);
 Solid_Strip( 254,64,20 );
 delay(2000);

 LCD_Out(2, 1, Message27);
 delay(2000);
 Solid_Strip( 0,255,0 );

 LCD_Out(2, 1, Message22);
 delay(2000);
 for(counter = 0; counter < 45; counter ++)
 {
 pos = rand() % MAX_LED_COUNT;
 m = rand() % 63;
 b = rand() % 63;
 o = rand() % 63;
 srand(o);
 Fill_Dot(m, n, o, pos);
 }
 delay(1000);

 LCD_Out(2, 1, Message11);
 delay(2000);
 MovLeft_Chase_and_Clear(MAX_LED_COUNT);

 LCD_Out(2, 1, Message11);
 delay(2000);
 MovRight_Chase_and_Clear(MAX_LED_COUNT);

 LCD_Out(2, 1, Message27);
 delay(2000);
 Solid_Strip( 0,255,0 );
 delay(100);
 Solid_Strip( 255,0,0 );
 delay(100);
 Solid_Strip( 0,0,255 );
 delay(100);
 Solid_Strip( 20,255,0 );
 delay(100);

 LCD_Out(2, 1, Message16);
 delay(2000);
 rainbowCycleRight(2, 5);

 LCD_Out(2, 1, Message17);
 delay(2000);
 rainbowCycleLeft(2, 5);

 LCD_Out(2, 1, Message10);
 delay(2000);

 FillLeft( 0,255,0 );
 FillRight( 0,0,0 );
 FillRight( 255,0,0 );
 FillRight( 0,0,0 );
 FillRight( 3,220,3 );
 FillLeft( 0,0,0 );
 FillRight( 20,255,0 );
 FillRight( 0,0,0 );
 FillRight( 254,64,20 );
 FillRight( 0,0,0 );
 FillRight( 0,0,0 );
 FillLeft( 255,255,255 );
 FillLeft( 0,0,0 );
 FillRight( 255,0,255 );
 FillRight( 0,0,0 );

 LCD_Out(2, 1, Message27);
 delay(2000);
for(counter = 0; counter < 5; ++counter)
 {
 Solid_Strip( 0,255,0 );
 delay(200);
 Solid_Strip( 255,0,0 );
 delay(200);
 Solid_Strip( 0,0,255 );
 delay(200);
 Solid_Strip( 20,255,0 );
 delay(200);
 Solid_Strip( 0,75,130 );
 delay(200);
 Solid_Strip( 254,64,20 );
 delay(200);
 Solid_Strip( 255,255,0 );
 delay(200);
 Solid_Strip( 255,0,255 );
 delay(200);
 Solid_Strip( 0,255,255 );
 delay(200);
 Solid_Strip( 220,100,47 );
 delay(200);
 Solid_Strip( 245,40,100 );
 delay(200);
 Solid_Strip( 30,255,12 );
 delay(200);
 Solid_Strip( 255,255,255 );
 delay(200);
 Solid_Strip( 160,255,0 );
 delay(200);
 Solid_Strip( 206,135,255 );
 delay(200);
 }

 LCD_Out(2, 1, Message23);
 delay(2000);
 Chase_3Color_Right( 255,0,255 ,  20,255,0 ,  254,64,20 , 150);

 LCD_Out(2, 1, Message15);
 delay(2000);
 Fade_Strip( 0,0,0 ,  20,255,0 , 0);
 Fade_Strip( 20,255,0 ,  0,0,255 , 0);
 Fade_Strip( 0,0,255 ,  0,255,0 , 0);
 Fade_Strip( 0,255,0 ,  255,0,0 , 0);
 Fade_Strip( 255,0,0 ,  0,75,130 , 0);
 delay(2000);

 LCD_Out(2, 1, Message23);
 delay(2000);
for(counter = 0; counter < 5; ++counter)
 {
 Chase_3Color_Right( 255,0,0 ,  255,0,0 ,  255,0,0 , repeat);
 Chase_3Color_Left( 0,255,0 ,  0,255,0 ,  0,255,0 , repeat);
 Chase_3Color_Right( 255,0,255 ,  255,0,255 ,  255,0,255 , repeat);
 Chase_3Color_Left( 0,0,255 ,  0,0,255 ,  0,0,255 , repeat);
 Chase_3Color_Right( 0,255,255 ,  0,255,255 ,  0,255,255 , repeat);
 Chase_3Color_Left( 160,255,0 ,  160,255,0 ,  160,255,0 , repeat);
 Chase_3Color_Right( 0,75,130 ,  0,75,130 ,  0,75,130 , repeat);
 Chase_3Color_Left( 254,64,20 ,  254,64,20 ,  254,64,20 , repeat);
 Chase_3Color_Right( 255,255,0 ,  255,255,0 ,  255,255,0 , repeat);
 Chase_3Color_Left( 206,135,255 ,  206,135,255 ,  206,135,255 , repeat);
 }

 LCD_Out(2, 1, Message25);
 delay(2000);
 Fill_Any_PosR( 0,255,0 ,  0,0,255 ,  255,0,0 , 0, MAX_LED_COUNT);
 MovLeft_Chase_and_Clear(MAX_LED_COUNT);
 Fill_Any_PosR( 0,255,0 ,  255,0,0 ,  255,255,0 , MAX_LED_COUNT, 0);
 delay(10);
 MovRight_Chase_and_Clear(MAX_LED_COUNT);
 FillLeft( 0,75,130 );
 Fill_Any_PosR( 0,255,255 ,  0,0,0 ,  0,0,0 , MAX_LED_COUNT, 0);
 MovRight_Chase_and_Clear(MAX_LED_COUNT);
 Fill_Any_PosR( 160,255,0 ,  160,255,0 ,  160,255,0 , 0, MAX_LED_COUNT);
 delay(10);
 MovLeft_Chase_and_Clear(MAX_LED_COUNT);
 FillRight( 206,135,255 );

 LCD_Out(2, 1, Message26);
 delay(2000);
 Fill_Any_PosL( 0,0,255 ,  255,255,0 ,  255,255,0 , MAX_LED_COUNT - 1, 0);
 delay(100);
 Fill_Any_PosL( 254,64,20 ,  20,255,0 ,  30,255,12 , MAX_LED_COUNT - 1, 0);
 delay(100);
 Fill_Any_PosL( 0,255,255 ,  0,0,255 ,  255,255,0 , MAX_LED_COUNT - 1, 0);
 delay(100);
 Fill_Any_PosL( 40,40,40 ,  0,75,130 ,  40,40,40 , MAX_LED_COUNT - 1, 0);
 delay(100);
 Fill_Any_PosL( 160,255,0 ,  255,0,255 ,  3,220,3 , MAX_LED_COUNT - 1, 0);
 delay(100);
 Fill_Any_PosL( 0,255,0 ,  255,0,0 ,  0,255,0 , MAX_LED_COUNT - 1, 0);
 delay(100);
 FillRight( 0,0,0 );


 }
}
