#include "WS2811.h"
#include "Delay_Sub.h"
//***************************************************************************
// WS2811.c  LED Strip Display Demo Program
// For PIC 18F45K22/18F46K22
// EasyPICv7 Development Board
// Crystal 16 MHz  HSPLL 64Mhz
// Works with WS2811/WS2812 LEDs
//
// LCD on PORTB
// LED Sequence Speed Pot RA0 = ADC_Read(0)
// Thanks to Patrick Cantwell for the cool WS2811 Frame Routine!
// LED Order is G, R, B.   verify Colors in WS2811_Init.h
// LED Strip - +5V, IN, GND
// Pin 24,  RC5,  Data Out to LED In
//
// Use with WS2811.h
// WS2811_LEDCount(55);      // Sets Total Number of LEDS within strip
// WS2811_AtoD(row, col, AtoD Ch, Display On/Off)
// (Sets Display Position, AtoD channel and Display Value On/Off
// RCI 3-02-2014
//***************************************************************************
// Lcd module connections
sbit LCD_RS at LATB4_bit;
sbit LCD_EN at LATB5_bit;
sbit LCD_D4 at LATB0_bit;
sbit LCD_D5 at LATB1_bit;
sbit LCD_D6 at LATB2_bit;
sbit LCD_D7 at LATB3_bit;

sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;
// End Lcd module connections
//***************************************************************************
//Variable Declarations
//***************************************************************************
//                    1234567890123456
char Message1[17]  = "WS2811 Demo     ";
char Message2[17]  = "P18F45K22  V1.0 ";
char Message3[17]  = "Chase Right     ";
char Message4[17]  = "Chase Left      ";
char Message5[17]  = "Fill Right      ";
char Message6[17]  = "Fill Left       ";
char Message7[17]  = "Fill Right Clear";
char Message8[17]  = "Fill Left Clear ";
char Message9[17]  = "Fill Strip      ";
char Message10[17] = "Insert Color    ";
char Message11[17] = "Move Left Clear ";
char Message12[17] = "Move Right Clear";
char Message13[17] = "Fill Short Left ";
char Message14[17] = "Fill Short Right";
char Message15[17] = "Fade Strip      ";
char Message16[17] = "Rainbow Right   ";
char Message17[17] = "Rainbow Left    ";
char Message18[17] = "Comet Left      ";
char Message19[17] = "Comet Right     ";
char Message20[17] = "Fill Dot Pos R  ";
char Message21[17] = "Fill Dot Pos L  ";
char Message22[17] = "Fill Dots       ";
char Message23[17] = "Chase 3 Color R ";
char Message24[17] = "Chase 3 Color L ";
char Message25[17] = "Fill Any Pos R  ";
char Message26[17] = "Fill Any Pos L  ";
char Message27[17] = "Solid Strip     ";
char Message28[17] = "Chase Random    ";
char Message29[17] = "Random Color    ";
char Message90[17] = "Delay";
char Message99[17] = "                ";
char pos, noc, strt, repeat;
char m, b, o;
unsigned char old[5], new[5], count[5];
unsigned char step, counter;
unsigned int disp_spd;

//****************************************************************************
//****************************************************************************
void main(void) 
{
         //  76543210
  ANSELA = 0b00000001;        // RA0 is Analog In
  ANSELB = 0b00000000;
  ANSELC = 0b00000000;
  ANSELD = 0b00000000;
  ANSELE = 0b00000000;
  PORTA  = 0b00000000;        // PORT Clear
  PORTB  = 0b00000000;        // PORT Clear
  PORTC  = 0b00000000;        // PORT Clear
  PORTD  = 0b00000000;        // PORT Clear
  TRISA  = 0b00000001;        // RA0 Input
  TRISB  = 0b00000000;
  TRISC  = 0b00000000;
  TRISD  = 0b00000000;
  TRISE  = 0b00000000;
//****************************************************************************
// Initialize Serial LCD Display
//****************************************************************************
  LCD_Init();                       // Initialize LCD Display
  Delay(100);
  ADC_Init();                       // Initialize A to D Input
  LCD_Out(1, 1, Message1);
  LCD_Out(2, 1, Message2);
  Delay(4000);
  LCD_Out(1, 1, Message99);
  LCD_Out(1, 1, Message90);
  LCD_Out(2, 1, Message99);
  LCD_Cmd(_LCD_CURSOR_OFF);
// Set up MCU for proper bit rate for WS2811 LED
  SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV16, _SPI_DATA_SAMPLE_MIDDLE,
  _SPI_CLK_IDLE_LOW, _SPI_LOW_2_HIGH);
  delay(250);
  speede = 0;                       // Sets LED Sequence Speed to Zero
  WS2811_LEDCount(55);              // Sets Total Number of LEDS in strip
  WS2811_AtoD_Display(1, 6, 0, 1);  // Setup AtoD Display Value for Speed
  Solid_Strip(black);               // Clears Strip
//****************************************************************************
while(1 == 1)
{
// Test Color Patterns,  create your own,  See WS2811.h for Examples
   LCD_Out(2, 1, Message19);
   delay(1000);
   CometRight(red);

   LCD_Out(2, 1, Message18);
   delay(1000);
   CometLeft(green);

   LCD_Out(2, 1, Message19);
   delay(1000);
   CometRight(blue);

   LCD_Out(2, 1, Message16);
   delay(1000);
   rainbowCycleRight(1, 5);

   LCD_Out(2, 1, Message29);
   delay(1000);
   RandomColor(1000, 5);
   
   LCD_Out(2, 1, Message16);
   delay(1000);
   rainbowCycleRight(1, 5);

for(counter = 0; counter < 2; ++counter)
   {
   InsertColor(black );
   InsertColor(turq);
   InsertColor(magenta );
   InsertColor(yellow);
   InsertColor(pink );
   InsertColor(red);
   InsertColor(white );
   InsertColor(crimson);
   InsertColor(green );
   InsertColor(orange);
   InsertColor(blue );
   InsertColor(olive);
   InsertColor(purple );
   InsertColor(lime);
   InsertColor(skyblue );
   InsertColor(gold);
   }
   
   LCD_Out(2, 1, Message22);
   delay(2000);
   Fill_Dot_PosR(red, 0, 15);
   delay(100);
   Fill_Dot_PosR(green, 20, 35);
   delay(100);
   Fill_Dot_PosR(blue, 40, 55);
   delay(2000);
   
   LCD_Out(2, 1, Message27);
   delay(2000);
   Solid_Strip(black);
   delay(2000);
   Solid_Strip(gold);
   delay(2000);
   Solid_Strip(pink);
   delay(2000);
   Solid_Strip(lime);
   delay(2000);
   
   LCD_Out(2, 1, Message27);
   delay(2000);
   Solid_Strip(red);

   LCD_Out(2, 1, Message22);
   delay(2000);
 for(counter = 0; counter < 45; counter ++)
   {
   pos = rand() % MAX_LED_COUNT;   //was 127
   m = rand() % 63;
   b = rand() % 63;
   o = rand() % 63;
   srand(o);
   Fill_Dot(m, n, o, pos);
   }
   delay(1000);
   
   LCD_Out(2, 1, Message11);
   delay(2000);
   MovLeft_Chase_and_Clear(MAX_LED_COUNT);
   
   LCD_Out(2, 1, Message11);
   delay(2000);
   MovRight_Chase_and_Clear(MAX_LED_COUNT);

   LCD_Out(2, 1, Message27);
   delay(2000);
   Solid_Strip(red);
   delay(100);
   Solid_Strip(green);
   delay(100);
   Solid_Strip(blue);
   delay(100);
   Solid_Strip(orange);
   delay(100);
  
   LCD_Out(2, 1, Message16);
   delay(2000);
   rainbowCycleRight(2, 5);
   
   LCD_Out(2, 1, Message17);
   delay(2000);
   rainbowCycleLeft(2, 5);

   LCD_Out(2, 1, Message10);
   delay(2000);

   FillLeft(red);
   FillRight(black);
   FillRight(green);
   FillRight(black);
   FillRight(crimson);
   FillLeft(black);
   FillRight(orange);
   FillRight(black);
   FillRight(lime);
   FillRight(black);
   FillRight(black);
   FillLeft(white);
   FillLeft(black);
   FillRight(cyan);
   FillRight(black);

   LCD_Out(2, 1, Message27);
   delay(2000);
for(counter = 0; counter < 5; ++counter)
   {
   Solid_Strip(red);
   delay(200);
   Solid_Strip(green);
   delay(200);
   Solid_Strip(blue);
   delay(200);
   Solid_Strip(orange);
   delay(200);
   Solid_Strip(purple);
   delay(200);
   Solid_Strip(lime);
   delay(200);
   Solid_Strip(yellow);
   delay(200);
   Solid_Strip(cyan);
   delay(200);
   Solid_Strip(magenta);
   delay(200);
   Solid_Strip(olive);
   delay(200);
   Solid_Strip(turq);
   delay(200);
   Solid_Strip(pink);
   delay(200);
   Solid_Strip(white);
   delay(200);
   Solid_Strip(gold);
   delay(200);
   Solid_Strip(skyblue);
   delay(200);
   }
   
   LCD_Out(2, 1, Message23);
   delay(2000);
   Chase_3Color_Right(cyan, orange, lime, 150);

   LCD_Out(2, 1, Message15);
   delay(2000);
   Fade_Strip(black, orange, 0);
   Fade_Strip(orange, blue, 0);
   Fade_Strip(blue, red, 0);
   Fade_Strip(red, green, 0);
   Fade_Strip(green, purple, 0);
   delay(2000);

   LCD_Out(2, 1, Message23);
   delay(2000);
for(counter = 0; counter < 5; ++counter)
   {
   Chase_3Color_Right(green, green, green, repeat);
   Chase_3Color_Left(red, red, red, repeat);
   Chase_3Color_Right(cyan, cyan, cyan, repeat);
   Chase_3Color_Left(blue, blue, blue, repeat);
   Chase_3Color_Right(magenta, magenta, magenta, repeat);
   Chase_3Color_Left(gold, gold, gold, repeat);
   Chase_3Color_Right(purple, purple, purple, repeat);
   Chase_3Color_Left(lime, lime, lime, repeat);
   Chase_3Color_Right(yellow, yellow, yellow, repeat);
   Chase_3Color_Left(skyblue, skyblue, skyblue, repeat);
   }
   
   LCD_Out(2, 1, Message25);
   delay(2000);
   Fill_Any_PosR(red, blue, green, 0, MAX_LED_COUNT);
   MovLeft_Chase_and_Clear(MAX_LED_COUNT);
   Fill_Any_PosR(red, green, yellow, MAX_LED_COUNT, 0);
   delay(10);
   MovRight_Chase_and_Clear(MAX_LED_COUNT);
   FillLeft(purple);
   Fill_Any_PosR(magenta, black, black, MAX_LED_COUNT, 0);
   MovRight_Chase_and_Clear(MAX_LED_COUNT);
   Fill_Any_PosR(gold, gold, gold, 0, MAX_LED_COUNT);
   delay(10);
   MovLeft_Chase_and_Clear(MAX_LED_COUNT);
   FillRight(skyblue);

   LCD_Out(2, 1, Message26);
   delay(2000);
   Fill_Any_PosL(blue, yellow, yellow, MAX_LED_COUNT - 1, 0);
   delay(100);
   Fill_Any_PosL(lime, orange, pink, MAX_LED_COUNT - 1, 0);
   delay(100);
   Fill_Any_PosL(magenta, blue, yellow, MAX_LED_COUNT - 1, 0);
   delay(100);
   Fill_Any_PosL(grey, purple, grey, MAX_LED_COUNT - 1, 0);
   delay(100);
   Fill_Any_PosL(gold, cyan, crimson, MAX_LED_COUNT - 1, 0);
   delay(100);
   Fill_Any_PosL(red, green, red, MAX_LED_COUNT - 1, 0);
   delay(100);
   FillRight(black);

   
  }// End While
}// End Main
//****************************************************************************
//****************************************************************************